gtk3-0.15.10: Binding to the Gtk+ 3 graphical user interface library

Maintainer | gtk2hs-users@lists.sourceforge.net
Stability | provisional
Portability | portable (depends on GHC)
Safe Haskell | None
Language | Haskell98

Graphics.UI.Gtk.Misc.HandleBox

Contents

- Detail
- Class Hierarchy
- Types
- Constructors
- Methods
- Attributes
- Signals

Description

a widget for detachable window portions

Synopsis

- data HandleBox
- class BinClass o => HandleBoxClass o
- castToHandleBox :: GObjectClass obj => obj -> HandleBox
- gTypeHandleBox :: GType
- toHandleBox :: HandleBoxClass o => o -> HandleBox
- handleBoxNew :: IO HandleBox
- data ShadowType
  - = ShadowNone
  - | ShadowIn
  - | ShadowOut
  - | ShadowEtchedIn
  - | ShadowEtchedOut
- handleBoxSetShadowType :: HandleBoxClass self => self -> ShadowType -> IO ()
- handleBoxGetShadowType :: HandleBoxClass self => self -> IO ShadowType
- data PositionType
  - = PosLeft
  - | PosRight
  - | PosTop
  - | PosBottom
- handleBoxSetHandlePosition :: HandleBoxClass self => self -> PositionType -> IO ()
- handleBoxGetHandlePosition :: HandleBoxClass self => self -> IO PositionType
- handleBoxSetSnapEdge :: HandleBoxClass self => self -> PositionType -> IO ()
- handleBoxGetSnapEdge :: HandleBoxClass self => self -> IO PositionType
- handleBoxShadowType :: HandleBoxClass self => Attr self ShadowType
- handleBoxHandlePosition :: HandleBoxClass self => Attr self PositionType
- handleBoxSnapEdge :: HandleBoxClass self => Attr self PositionType
- handleBoxSnapEdgeSet :: HandleBoxClass self => Attr self Bool
- onChildAttached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)
- afterChildAttached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)
- onChildDetached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)
- afterChildDetached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self)

# Detail

The `HandleBox` widget allows a portion of a window to be "torn off". It is a bin widget which displays its child and a handle that the user can drag to tear off a separate window (the float window) containing the child widget. A thin ghost is drawn in the original location of the handlebox. By dragging the separate window back to its original location, it can be reattached.

When reattaching, the ghost and float window, must be aligned along one of the edges, the snap edge. This either can be specified by the application programmer explicitly, or Gtk+ will pick a reasonable default based on the handle position.

To make detaching and reattaching the handlebox as minimally confusing as possible to the user, it is important to set the snap edge so that the snap edge does not move when the handlebox is detached. For instance, if the handlebox is packed at the bottom of a VBox, then when the handlebox is detached, the bottom edge of the handlebox's allocation will remain fixed as the height of the handlebox shrinks, so the snap edge should be set to `PosBottom`.

# Class Hierarchy

    | GObject
    | +----Object
    | +----Widget
    | +----Container
    | +----Bin
    | +----HandleBox

# Types

data HandleBox Source #

#### Instances

Instances details

Eq HandleBox Source # |
Instance details Defined in Graphics.UI.Gtk.Types Methods (==) :: HandleBox -> HandleBox -> Bool Source # (/=) :: HandleBox -> HandleBox -> Bool Source #
Ord HandleBox Source # |

Instance details

Defined in Graphics.UI.Gtk.Types

Methods

compare :: HandleBox -> HandleBox -> Ordering Source #

(<) :: HandleBox -> HandleBox -> Bool Source #

(<=) :: HandleBox -> HandleBox -> Bool Source #

(>) :: HandleBox -> HandleBox -> Bool Source #

(>=) :: HandleBox -> HandleBox -> Bool Source #

max :: HandleBox -> HandleBox -> HandleBox Source #

min :: HandleBox -> HandleBox -> HandleBox Source #

GObjectClass HandleBox Source # |
Instance details Defined in Graphics.UI.Gtk.Types Methods toGObject :: HandleBox -> GObject Source # unsafeCastGObject :: GObject -> HandleBox Source #
BinClass HandleBox Source # |
Instance details Defined in Graphics.UI.Gtk.Types
ContainerClass HandleBox Source # |
Instance details Defined in Graphics.UI.Gtk.Types
HandleBoxClass HandleBox Source # |
Instance details Defined in Graphics.UI.Gtk.Types
WidgetClass HandleBox Source # |
Instance details Defined in Graphics.UI.Gtk.Types

class BinClass o => HandleBoxClass o Source #

#### Instances

Instances details

HandleBoxClass HandleBox Source # |
Instance details Defined in Graphics.UI.Gtk.Types

castToHandleBox :: GObjectClass obj => obj -> HandleBox Source #

gTypeHandleBox :: GType Source #

toHandleBox :: HandleBoxClass o => o -> HandleBox Source #

# Constructors

handleBoxNew :: IO HandleBox Source #

Create a new handle box.

# Methods

data ShadowType Source #

Shadow types

Constructors

ShadowNone |
ShadowIn |
ShadowOut |
ShadowEtchedIn |
ShadowEtchedOut |

#### Instances

Instances details

Enum ShadowType Source # |

Instance details

Defined in Graphics.UI.Gtk.General.Enums

Methods

succ :: ShadowType -> ShadowType Source #

pred :: ShadowType -> ShadowType Source #

toEnum :: Int -> ShadowType Source #

fromEnum :: ShadowType -> Int Source #

enumFrom :: ShadowType -> [ShadowType] Source #

enumFromThen :: ShadowType -> ShadowType -> [ShadowType] Source #

enumFromTo :: ShadowType -> ShadowType -> [ShadowType] Source #

enumFromThenTo :: ShadowType -> ShadowType -> ShadowType -> [ShadowType] Source #

Show ShadowType Source # |
Instance details Defined in Graphics.UI.Gtk.General.Enums Methods showsPrec :: Int -> ShadowType -> ShowS Source # show :: ShadowType -> String Source # showList :: [ShadowType] -> ShowS Source #
Eq ShadowType Source # |
Instance details Defined in Graphics.UI.Gtk.General.Enums Methods (==) :: ShadowType -> ShadowType -> Bool Source # (/=) :: ShadowType -> ShadowType -> Bool Source #

handleBoxSetShadowType :: HandleBoxClass self => self -> ShadowType -> IO () Source #

Sets the type of shadow to be drawn around the border of the handle box.

handleBoxGetShadowType Source #

Arguments

:: HandleBoxClass self |
=> self |
-> IO ShadowType | returns the type of shadow currently drawn around the handle box.

Gets the type of shadow drawn around the handle box. See `handleBoxSetShadowType`.

data PositionType Source #

Position a scale's value is drawn relative to the through

Constructors

PosLeft |
PosRight |
PosTop |
PosBottom |

#### Instances

Instances details

Enum PositionType Source # |

Instance details

Defined in Graphics.UI.Gtk.General.Enums

Methods

succ :: PositionType -> PositionType Source #

pred :: PositionType -> PositionType Source #

toEnum :: Int -> PositionType Source #

fromEnum :: PositionType -> Int Source #

enumFrom :: PositionType -> [PositionType] Source #

enumFromThen :: PositionType -> PositionType -> [PositionType] Source #

enumFromTo :: PositionType -> PositionType -> [PositionType] Source #

enumFromThenTo :: PositionType -> PositionType -> PositionType -> [PositionType] Source #

Show PositionType Source # |
Instance details Defined in Graphics.UI.Gtk.General.Enums Methods showsPrec :: Int -> PositionType -> ShowS Source # show :: PositionType -> String Source # showList :: [PositionType] -> ShowS Source #
Eq PositionType Source # |
Instance details Defined in Graphics.UI.Gtk.General.Enums Methods (==) :: PositionType -> PositionType -> Bool Source # (/=) :: PositionType -> PositionType -> Bool Source #

handleBoxSetHandlePosition Source #

Arguments

:: HandleBoxClass self |
=> self |
-> PositionType | `position` - the side of the handlebox where the handle should be drawn.
-> IO () |

Sets the side of the handlebox where the handle is drawn.

handleBoxGetHandlePosition Source #

Arguments

:: HandleBoxClass self |
=> self |
-> IO PositionType | returns the current handle position.

Gets the handle position of the handle box. See `handleBoxSetHandlePosition`.

handleBoxSetSnapEdge :: HandleBoxClass self => self -> PositionType -> IO () Source #

Sets the snap edge of the HandleBox. The snap edge is the edge of the detached child that must be aligned with the corresponding edge of the "ghost" left behind when the child was detached to reattach the torn-off window. Usually, the snap edge should be chosen so that it stays in the same place on the screen when the handlebox is torn off.

If the snap edge is not set, then an appropriate value will be guessed from the handle position. If the handle position is `PosRight` or `PosLeft`, then the snap edge will be `PosTop`, otherwise it will be `PosLeft`.

handleBoxGetSnapEdge :: HandleBoxClass self => self -> IO PositionType Source #

Gets the edge used for determining reattachment of the handle box. See `handleBoxSetSnapEdge`.

# Attributes

handleBoxShadowType :: HandleBoxClass self => Attr self ShadowType Source #

Appearance of the shadow that surrounds the container.

Default value: `ShadowEtchedOut`

handleBoxHandlePosition :: HandleBoxClass self => Attr self PositionType Source #

Position of the handle relative to the child widget.

Default value: `PosLeft`

handleBoxSnapEdge :: HandleBoxClass self => Attr self PositionType Source #

Side of the handlebox that's lined up with the docking point to dock the handlebox.

Default value: `PosTop`

handleBoxSnapEdgeSet :: HandleBoxClass self => Attr self Bool Source #

Whether to use the value from the snap_edge property or a value derived from handle_position.

Default value: `False`

# Signals

onChildAttached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self) Source #

This signal is emitted when the contents of the handlebox are reattached to the main window.

afterChildAttached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self) Source #

This signal is emitted when the contents of the handlebox are reattached to the main window.

onChildDetached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self) Source #

This signal is emitted when the contents of the handlebox are detached from the main window.

afterChildDetached :: HandleBoxClass self => self -> IO () -> IO (ConnectId self) Source #

This signal is emitted when the contents of the handlebox are detached from the main window.